<?php
namespace ZWEI14\Captcha\ViewHelpers;

use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;
use TYPO3Fluid\Fluid\Core\ViewHelper\Traits\CompileWithRenderStatic;
use ZWEI14\Captcha\Interfaces\Options;

final class CaptchaViewHelper extends AbstractViewHelper implements Options
{
    use CompileWithRenderStatic;

    protected $escapeOutput = false;

    public function initializeArguments()
    {
        // registerArgument($name, $type, $description, $required, $defaultValue, $escape)
        // $this->registerArgument('emailAddress', 'string', 'The email address to resolve the gravatar for', true);
    }

    public static function renderStatic(
        array $arguments,
        \Closure $renderChildrenClosure,
        RenderingContextInterface $renderingContext
        )
    {

        $validOptionKey = array_rand(($all = Options::OPTIONS));
        $readableValidOptionKey = Options::READABLE_OPTIONS[$validOptionKey];
        $validOptions = $all[$validOptionKey];

        $options = array_merge(
            //Options::AIRPLANES, 
            Options::BRUSHES, 
            Options::MOONS, 
            Options::PENCILS, 
            Options::PHONES
        );
        
        // this is improved with the TagBasedViewHelper (see below)
        shuffle($options);
        return [
            'options' => $options,
            'validOptionKey' => $validOptionKey,
            'readableValidOptionKey' => $readableValidOptionKey,
            'validOptions' => $validOptions
        ];
    }

    public static function shuffle_assoc($list) { 
        if (!is_array($list)) return $list; 
      
        $keys = array_keys($list); 
        shuffle($keys); 
        $random = array(); 
        foreach ($keys as $key) { 
          $random[$key] = $list[$key]; 
        }
        return $random; 
      } 
}